"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MiscApi = void 0;
/*
 * Copyright (c) 2022-2023 AccelByte Inc. All Rights Reserved
 * This is licensed software from AccelByte Inc, for limitations
 * and restrictions contact your company contract manager.
 */
/**
 * AUTO GENERATED
 */
/* eslint-disable camelcase */
const sdk_1 = require("@accelbyte/sdk");
const Misc__js_1 = require("./endpoints/Misc$.js");
function MiscApi(sdk, args) {
    const sdkAssembly = sdk.assembly();
    const namespace = args?.namespace ? args?.namespace : sdkAssembly.namespace;
    const cache = args?.cache ? args?.cache : sdkAssembly.cache;
    const requestConfig = sdk_1.ApiUtils.mergedConfigs(sdkAssembly.config, args);
    /**
     * Get server time
     */
    async function getMiscTime() {
        const $ = new Misc__js_1.Misc$(sdk_1.Network.create(requestConfig), namespace, cache);
        const resp = await $.getMiscTime();
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    /**
     * List languages.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: language list&lt;/li&gt;&lt;/ul&gt;
     */
    async function getMiscLanguages() {
        const $ = new Misc__js_1.Misc$(sdk_1.Network.create(requestConfig), namespace, cache);
        const resp = await $.getMiscLanguages();
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    /**
     * List time zones.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: time zones&lt;/li&gt;&lt;/ul&gt;
     */
    async function getMiscTimezones() {
        const $ = new Misc__js_1.Misc$(sdk_1.Network.create(requestConfig), namespace, cache);
        const resp = await $.getMiscTimezones();
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    return {
        getMiscTime,
        getMiscLanguages,
        getMiscTimezones
    };
}
exports.MiscApi = MiscApi;
