"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Misc$ = void 0;
/*
 * Copyright (c) 2022-2023 AccelByte Inc. All Rights Reserved
 * This is licensed software from AccelByte Inc, for limitations
 * and restrictions contact your company contract manager.
 */
/**
 * AUTO GENERATED
 */
const sdk_1 = require("@accelbyte/sdk");
const zod_1 = require("zod");
const RetrieveTimeResponse_js_1 = require("../definitions/RetrieveTimeResponse.js");
class Misc$ {
    // @ts-ignore
    constructor(axiosInstance, namespace, cache = false) {
        this.axiosInstance = axiosInstance;
        this.namespace = namespace;
        this.cache = cache;
    }
    /**
     * Get server time
     */
    getMiscTime() {
        const params = {};
        const url = '/basic/v1/public/misc/time';
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, RetrieveTimeResponse_js_1.RetrieveTimeResponse, 'RetrieveTimeResponse');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * List languages.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: language list&lt;/li&gt;&lt;/ul&gt;
     */
    getMiscLanguages() {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/misc/languages'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, zod_1.z.unknown(), 'z.unknown()');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * List time zones.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: time zones&lt;/li&gt;&lt;/ul&gt;
     */
    getMiscTimezones() {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/misc/timezones'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, zod_1.z.unknown(), 'z.unknown()');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
}
exports.Misc$ = Misc$;
