"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserProfile$ = void 0;
/*
 * Copyright (c) 2022-2023 AccelByte Inc. All Rights Reserved
 * This is licensed software from AccelByte Inc, for limitations
 * and restrictions contact your company contract manager.
 */
/**
 * AUTO GENERATED
 */
const sdk_1 = require("@accelbyte/sdk");
const zod_1 = require("zod");
const UserProfileInfo_js_1 = require("../definitions/UserProfileInfo.js");
const UserProfilePrivateInfo_js_1 = require("../definitions/UserProfilePrivateInfo.js");
const UserProfilePublicInfo_js_1 = require("../definitions/UserProfilePublicInfo.js");
const UserProfilePublicInfoArray_js_1 = require("../definitions/UserProfilePublicInfoArray.js");
const UserZipCode_js_1 = require("../definitions/UserZipCode.js");
class UserProfile$ {
    // @ts-ignore
    constructor(axiosInstance, namespace, cache = false) {
        this.axiosInstance = axiosInstance;
        this.namespace = namespace;
        this.cache = cache;
    }
    /**
     * Get user public profile by ids.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11405&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user public profiles&lt;/li&gt;&lt;/ul&gt;
     */
    getProfilesPublic(queryParams) {
        const params = { ...queryParams };
        const url = '/basic/v1/public/namespaces/{namespace}/profiles/public'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, UserProfilePublicInfoArray_js_1.UserProfilePublicInfoArray, 'UserProfilePublicInfoArray');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * Get my profile&lt;br&gt;&lt;b&gt;Client with user token can get user profile in target namespace&lt;/b&gt;&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:PROFILE&#34;&lt;/b&gt;, action=2 &lt;b&gt;(READ)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11403&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user profile&lt;/li&gt;&lt;li&gt;&lt;i&gt;Path&#39;s namespace&lt;/i&gt; : &lt;ul&gt;&lt;li&gt;can be filled with &lt;b&gt;publisher namespace&lt;/b&gt; in order to get &lt;b&gt;publisher user profile&lt;/b&gt;&lt;/li&gt;&lt;li&gt;can be filled with &lt;b&gt;game namespace&lt;/b&gt; in order to get &lt;b&gt;game user profile&lt;/b&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Language&lt;/i&gt; : allowed format: en, en-US&lt;/li&gt;&lt;li&gt;&lt;i&gt;Timezone&lt;/i&gt; : IANA time zone, e.g. Asia/Shanghai&lt;/li&gt;&lt;/ul&gt;
     */
    getUsersMeProfiles() {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/me/profiles'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, UserProfilePrivateInfo_js_1.UserProfilePrivateInfo, 'UserProfilePrivateInfo');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * Create my profile.&lt;br&gt;&lt;b&gt;Client with user token can create user profile in target namespace&lt;/b&gt;&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:PROFILE&#34;&lt;/b&gt;, action=1 &lt;b&gt;(CREATE)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11401&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: Created user profile&lt;/li&gt;&lt;li&gt;&lt;i&gt;Path&#39;s namespace&lt;/i&gt; : &lt;ul&gt;&lt;li&gt;can be filled with &lt;b&gt;publisher namespace&lt;/b&gt; in order to create &lt;b&gt;publisher user profile&lt;/b&gt;&lt;/li&gt;&lt;li&gt;can be filled with &lt;b&gt;game namespace&lt;/b&gt; in order to create &lt;b&gt;game user profile&lt;/b&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Language&lt;/i&gt; : allowed format: en, en-US&lt;/li&gt;&lt;li&gt;&lt;i&gt;Country&lt;/i&gt; : ISO3166-1 alpha-2 two letter, e.g. US &lt;/li&gt;&lt;li&gt;&lt;i&gt;Timezone&lt;/i&gt; : IANA time zone, e.g. Asia/Shanghai&lt;/li&gt;&lt;/ul&gt;
     */
    createUserMeProfile(data) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/me/profiles'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.post(url, data, { params });
        return sdk_1.Validate.responseType(() => resultPromise, UserProfilePrivateInfo_js_1.UserProfilePrivateInfo, 'UserProfilePrivateInfo');
    }
    /**
     * Update my profile.&lt;br&gt;Updates user profile in the target namespace (namespace in the path). If token&#39;s namespace doesn&#39;t match the target namespace, the service automatically maps the token&#39;s user ID into the user ID in the target namespace. The endpoint returns the updated user profile on a successful call.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:PROFILE&#34;&lt;/b&gt;, action=4 &lt;b&gt;(UPDATE)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11402&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user profile&lt;/li&gt;&lt;li&gt;&lt;i&gt;Path&#39;s namespace&lt;/i&gt; : &lt;ul&gt;&lt;li&gt;can be filled with &lt;b&gt;publisher namespace&lt;/b&gt; in order to update &lt;b&gt;publisher user profile&lt;/b&gt;&lt;/li&gt;&lt;li&gt;can be filled with &lt;b&gt;game namespace&lt;/b&gt; in order to update &lt;b&gt;game user profile&lt;/b&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Language&lt;/i&gt; : allowed format: en, en-US&lt;/li&gt;&lt;li&gt;&lt;i&gt;Timezone&lt;/i&gt; : IANA time zone, e.g. Asia/Shanghai&lt;/li&gt;&lt;/ul&gt;
     */
    updateUserMeProfile(data) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/me/profiles'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.put(url, data, { params });
        return sdk_1.Validate.responseType(() => resultPromise, UserProfilePrivateInfo_js_1.UserProfilePrivateInfo, 'UserProfilePrivateInfo');
    }
    /**
     * Get user profile.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:USER:{userId}:PROFILE&#34;&lt;/b&gt;, action=2 &lt;b&gt;(READ)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11403&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user profile&lt;/li&gt;&lt;/ul&gt;
     */
    getProfiles_ByUserId(userId) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/{userId}/profiles'
            .replace('{namespace}', this.namespace)
            .replace('{userId}', userId);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, UserProfileInfo_js_1.UserProfileInfo, 'UserProfileInfo');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * Create user profile.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:USER:{userId}:PROFILE&#34;&lt;/b&gt;, action=1 &lt;b&gt;(CREATE)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11401&lt;/li&gt;&lt;li&gt;&lt;i&gt;Language&lt;/i&gt; : allowed format: en, en-US&lt;/li&gt;&lt;li&gt;&lt;i&gt;Timezone&lt;/i&gt; : IANA time zone, e.g. Asia/Shanghai&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: Created user profile&lt;/li&gt;&lt;/ul&gt;
     */
    createProfile_ByUserId(userId, data) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/{userId}/profiles'
            .replace('{namespace}', this.namespace)
            .replace('{userId}', userId);
        const resultPromise = this.axiosInstance.post(url, data, { params });
        return sdk_1.Validate.responseType(() => resultPromise, UserProfileInfo_js_1.UserProfileInfo, 'UserProfileInfo');
    }
    /**
     * Update user profile.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:USER:{userId}:PROFILE&#34;&lt;/b&gt;, action=4 &lt;b&gt;(UPDATE)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11402&lt;/li&gt;&lt;li&gt;&lt;i&gt;Language&lt;/i&gt; : allowed format: en, en-US&lt;/li&gt;&lt;li&gt;&lt;i&gt;Timezone&lt;/i&gt; : IANA time zone, e.g. Asia/Shanghai&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: Updated user profile&lt;/li&gt;&lt;/ul&gt;
     */
    updateProfile_ByUserId(userId, data) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/{userId}/profiles'
            .replace('{namespace}', this.namespace)
            .replace('{userId}', userId);
        const resultPromise = this.axiosInstance.put(url, data, { params });
        return sdk_1.Validate.responseType(() => resultPromise, UserProfileInfo_js_1.UserProfileInfo, 'UserProfileInfo');
    }
    /**
     * Get my zip code.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:PROFILE&#34;&lt;/b&gt;, action=2 &lt;b&gt;(READ)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11407&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user zip code&lt;/li&gt;&lt;/ul&gt;
     */
    getUsersMeProfilesZipCode() {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/me/profiles/zipCode'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, UserZipCode_js_1.UserZipCode, 'UserZipCode');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * Update my zip code.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:PROFILE&#34;&lt;/b&gt;, action=4 &lt;b&gt;(UPDATE)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11408&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user zip code&lt;/li&gt;&lt;/ul&gt;
     */
    patchUserMeProfileZipCode(data) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/me/profiles/zipCode'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.patch(url, data, { params });
        return sdk_1.Validate.responseType(() => resultPromise, UserZipCode_js_1.UserZipCode, 'UserZipCode');
    }
    /**
     * Get user public profile by public id.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user public profile&lt;/li&gt;&lt;/ul&gt;
     */
    getProfilesPublicByPublicId(queryParams) {
        const params = { ...queryParams };
        const url = '/basic/v1/public/namespaces/{namespace}/profiles/public/byPublicId'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, UserProfilePublicInfo_js_1.UserProfilePublicInfo, 'UserProfilePublicInfo');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * Get user profile public info.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11404&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user public profile&lt;/li&gt;&lt;/ul&gt;
     */
    getProfilesPublic_ByUserId(userId) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/{userId}/profiles/public'
            .replace('{namespace}', this.namespace)
            .replace('{userId}', userId);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, UserProfilePublicInfo_js_1.UserProfilePublicInfo, 'UserProfilePublicInfo');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * Update user profile status.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:USER:{userId}:PROFILE&#34;&lt;/b&gt;, action=4 &lt;b&gt;(UPDATE)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11406&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user profile&lt;/li&gt;&lt;/ul&gt;
     */
    patchProfileStatus_ByUserId(userId, data) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/{userId}/profiles/status'
            .replace('{namespace}', this.namespace)
            .replace('{userId}', userId);
        const resultPromise = this.axiosInstance.patch(url, data, { params });
        return sdk_1.Validate.responseType(() => resultPromise, UserProfileInfo_js_1.UserProfileInfo, 'UserProfileInfo');
    }
    /**
     * Get custom attributes info.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11404&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: user custom attributes&lt;/li&gt;&lt;/ul&gt;
     */
    getProfilesCustomAttributes_ByUserId(userId) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/{userId}/profiles/customAttributes'
            .replace('{namespace}', this.namespace)
            .replace('{userId}', userId);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, zod_1.z.unknown(), 'z.unknown()');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * Update partially custom attributes tied to user id.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:USER:{userId}:PROFILE&#34;&lt;/b&gt;, action=4 &lt;b&gt;(UPDATE)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11402&lt;/li&gt;&lt;li&gt;&lt;i&gt;Request body&lt;/i&gt; : allowed format: JSON object&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: Updated custom attributes&lt;/li&gt;&lt;/ul&gt;
     */
    updateProfileCustomAttribute_ByUserId(userId, data) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/{userId}/profiles/customAttributes'
            .replace('{namespace}', this.namespace)
            .replace('{userId}', userId);
        const resultPromise = this.axiosInstance.put(url, data, { params });
        return sdk_1.Validate.responseType(() => resultPromise, zod_1.z.unknown(), 'z.unknown()');
    }
    /**
     * Get my private custom attributes.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:PROFILE&#34;&lt;/b&gt;, action=2 &lt;b&gt;(READ)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: custom attributes&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11403&lt;/li&gt;&lt;/ul&gt;
     */
    getUsersMeProfilesPrivateCustomAttributes() {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/me/profiles/privateCustomAttributes'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => sdk_1.Validate.responseType(() => resultPromise, zod_1.z.unknown(), 'z.unknown()');
        if (!this.cache) {
            return sdk_1.SdkCache.withoutCache(res);
        }
        const cacheKey = url + sdk_1.CodeGenUtil.hashCode(JSON.stringify({ params }));
        return sdk_1.SdkCache.withCache(cacheKey, res);
    }
    /**
     * Update partially private custom attributes tied to me.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:PROFILE&#34;&lt;/b&gt;, action=4 &lt;b&gt;(UPDATE)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11402&lt;/li&gt;&lt;li&gt;&lt;i&gt;Request body&lt;/i&gt;: allowed format: JSON object&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: Updated custom attributes&lt;/li&gt;&lt;/ul&gt;
     */
    updateUserMeProfilePrivateCustomAttribute(data) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/me/profiles/privateCustomAttributes'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.put(url, data, { params });
        return sdk_1.Validate.responseType(() => resultPromise, zod_1.z.unknown(), 'z.unknown()');
    }
}
exports.UserProfile$ = UserProfile$;
