/*
 * Copyright (c) 2022-2023 AccelByte Inc. All Rights Reserved
 * This is licensed software from AccelByte Inc, for limitations
 * and restrictions contact your company contract manager.
 */
/**
 * AUTO GENERATED
 */
/* eslint-disable camelcase */
import { ApiUtils, Network } from '@accelbyte/sdk';
import { Misc$ } from './endpoints/Misc$.js';
export function MiscApi(sdk, args) {
    const sdkAssembly = sdk.assembly();
    const namespace = args?.namespace ? args?.namespace : sdkAssembly.namespace;
    const cache = args?.cache ? args?.cache : sdkAssembly.cache;
    const requestConfig = ApiUtils.mergedConfigs(sdkAssembly.config, args);
    /**
     * Get server time
     */
    async function getMiscTime() {
        const $ = new Misc$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getMiscTime();
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    /**
     * List languages.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: language list&lt;/li&gt;&lt;/ul&gt;
     */
    async function getMiscLanguages() {
        const $ = new Misc$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getMiscLanguages();
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    /**
     * List time zones.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: time zones&lt;/li&gt;&lt;/ul&gt;
     */
    async function getMiscTimezones() {
        const $ = new Misc$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getMiscTimezones();
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    return {
        getMiscTime,
        getMiscLanguages,
        getMiscTimezones
    };
}
